extends ../_docs-template

block vars
  - var activeLink = 'react';
  - var title = 'Input React Component | Framework7 React Documentation';

block docs-index

block content


  .docs-nav
    include ../_docs-menu-react
  .docs-content
    .motion-docs-page-title
      h1 Input / Form Elements React Components
      script(src="/js/motion/inputs.js")
      f7-motion-inputs(motion)

    p Form elements allow you to create flexible and beautiful Form layout. Form elements are just well known <a href="../docs/list-view.html">List View</a> (<b><a href="list-view.html">List</a> and <a href="list-item.html">List Item</a> React components</b>) but with few additional components.
    p Check out Framework7's <a href="../docs/inputs.html">Inputs / Form Elements</a> for their appearance.

    h2 Input Components
    p There are following components included:
    ul
      li `ListInput`  - list item input element
      li `Input`  - input element

    h2 Input Properties
    table.params-table
      thead
        tr
          th Prop
          th Type
          th Default
          th Description
      tbody
        tr
          th(colspan="4") &lt;ListInput&gt; properties
        tr
          td media
          td string
          td
          td List item media image URL
        tr
          td label
          td string
          td
          td Input's label text
        tr
          td floatingLabel
          td boolean
          td false
          td Enables floating label
        tr
          td outline
          td boolean
          td false
          td Makes input outline
        tr
          td input
          td boolean
          td true
          td Whether it should render input element or not. Disable if you want to use custom input inside.
        tr
          td type
          td string
          td
          td Input type. All default HTML5 input type, and few special ones:
            ul
              li <b>textarea</b> - to render textarea element
              li <b>select</b> - to render select element
              li <b>datepicker</b> - to open <a href="/docs/calendar.html" target="_blank">Calendar</a> on input focus
              li <b>colorpicker</b> - to open <a href="/docs/color-picker.html" target="_blank">Color Picker</a> on input focus
              li <b>texteditor</b> - to open <a href="/docs/text-editor.html" target="_blank">Text Editor</a> on input focus
        tr
          td resizable
          td boolean
          td false
          td Makes textarea resizable
        tr
          td inputStyle
          td object
          td
          td Value of input's "style" attribute, in case you need to pass extra styles
        tr
          td clearButton
          td boolean
          td false
          td Adds input clear button that will clear input value on click
        tr
          td validate
          td boolean
          td false
          td When enabled then input value will be validated on change based on passed "pattern" or based on input type. If you use custom validation and need more control on where to show/hide error message, then it is better to disable validation and use `error-message` together with `error-message-force` props.
        tr
          td validateOnBlur
          td boolean
          td false
          td When enabled then input will be validated on blur only.
        tr
          td onValidate
          td function
          td
          td Callback to be executed on input validation, returns boolean value indication whether the input is valid or not.
            ```jsx
              <ListInput
                type="email"
                validate
                :onValidate={(isValid) => setInputValid(isValid)}
              />
            ```
        tr
          td errorMessage
          td string
          td
          td Custom error message to show when input value is invalid
        tr
          td errorMessageForce
          td boolean
          td false
          td Force error message to force. Useful in case you use custom validation and want to show/hide error message when you need it
        tr
          td info
          td string
          td
          td Custom additional text with information about input
        tr
          td name
          td string
          td
          td Input name
        tr
          td placeholder
          td string
          td
          td Input placeholder
        tr
          td id
          td string
          td
          td Wrapping element ID attribute
        tr
          td inputId
          td string
          td
          td Input element ID attribute
        tr
          td value
          td string<br>number
          td
          td
            p Input value.
            p If `type="datepicker"` then value must be passed as what <a href="/docs/calendar.html" target="_blank">Calendar</a> accepts - Array with dates, for example `value={[new Date()]}`
            p If `type="colorpicker"` then value must be passed as what <a href="/docs/color-picker.html" target="_blank">Color Picker</a> accepts - Object with colors, for example `value={{hex: '#ff0000'}}`
            p If `type="texteditor"` then value should be HTML string
        tr
          td defaultValue
          td string<br>number
          td
          td Input value, in case of uncontrolled component
        tr
          td inputmode
          td string
          td
          td Value of input's native "inputmode" attribute
        tr
          td size
          td string<br>number
          td
          td Value of input's native "size" attribute
        tr
          td pattern
          td string
          td
          td Value of input's native "pattern" attribute
        tr
          td accept
          td string<br>number
          td
          td Value of input's native "accept" attribute
        tr
          td autocomplete
          td string
          td
          td Value of input's native "autocomplete" attribute
        tr
          td autofocus
          td boolean
          td false
          td Value of input's native "autofocus" attribute
        tr
          td autosave
          td string
          td
          td Value of input's native "autosave" attribute
        tr
          td disabled
          td boolean
          td false
          td Marks input as disabled
        tr
          td max
          td string<br>number
          td
          td Value of input's native "max" attribute
        tr
          td min
          td string<br>number
          td
          td Value of input's native "min" attribute
        tr
          td step
          td string<br>number
          td
          td Value of input's native "step" attribute
        tr
          td maxlength
          td string<br>number
          td
          td Value of input's native "maxlength" attribute
        tr
          td minlength
          td string<br>number
          td
          td Value of input's native "minlength" attribute
        tr
          td multiple
          td boolean
          td false
          td Value of input's native "multiple" attribute
        tr
          td readonly
          td boolean
          td false
          td Marks input as readonly
        tr
          td required
          td boolean
          td false
          td Marks input as required
        tr
          td tabindex
          td string<br>number
          td
          td Value of input's native "tabindex" attribute
        tr
          td noStoreData
          td boolean
          td false
          td Allows to ignore input value to be stored when using with <a href="../docs/form.html#form-storage">Form Storage</a>
        tr
          td ignoreStoreData
          td boolean
          td false
          td Same as previous
        tr
          td wrap
          td boolean
          td true
          td When enabled it will be wrapped in `<li>` element
        tr
          td calendarParams
          td object
          td
          td Object with <a href="../docs/calendar.html#calendar-parameters" target="_blank">Calendar Parameters</a> which is used when `type="datepicker"`
        tr
          td colorPickerParams
          td object
          td
          td Object with <a href="../docs/color-picker.html#color-picker-parameters" target="_blank">Color Picker Parameters</a> which is used when `type="colorpicker"`
        tr
          td textEditorParams
          td object
          td
          td Object with <a href="../docs/text-editor.html#text-editor-parameters" target="_blank">Text Editor Parameters</a> which is used when `type="texteditor"`
        tr
          th(colspan="4") &lt;Input&gt; properties
        tr
          td outline
          td boolean
          td false
          td Makes input outline
        tr
          td wrap
          td boolean
          td true
          td Defines should the input be wraped with `<div class="input">` element or not.
        tr
          td type
          td string
          td
          td Input type. All default HTML5 input type, and few special ones:
            ul
              li <b>textarea</b> - to render textarea element
              li <b>select</b> - to render select element
              li <b>datepicker</b> - to open <a href="/docs/calendar.html" target="_blank">Calendar</a> on input focus
              li <b>colorpicker</b> - to open <a href="/docs/color-picker.html" target="_blank">Color Picker</a> on input focus
              li <b>texteditor</b> - to open <a href="/docs/text-editor.html" target="_blank">Text Editor</a> on input focus
        tr
          td resizable
          td boolean
          td false
          td Makes textarea resizable
        tr
          td inputStyle
          td object
          td
          td Value of input's "style" attribute, in case you need to pass extra styles
        tr
          td clearButton
          td boolean
          td false
          td Adds input clear button that will clear input value on click
        tr
          td validate
          td boolean
          td false
          td When enabled then input value will be validated on change based on passed "pattern" or based on input type. If you use custom validation and need more control on where to show/hide error message, then it is better to disable validation and use `error-message` together with `error-message-force` props.
        tr
          td validateOnBlur
          td boolean
          td false
          td When enabled then input will be validated on blur only.
        tr
          td onValidate
          td function
          td
          td Callback to be executed on input validation, returns boolean value indication whether the input is valid or not.
            ```jsx
              <Input
                type="email"
                validate
                :onValidate={(isValid) => setInputValid(isValid)}
              />
            ```
        tr
          td errorMessage
          td string
          td
          td Custom error message to show when input value is invalid
        tr
          td errorMessageForce
          td boolean
          td false
          td Force error message to force. Useful in case you use custom validation and want to show/hide error message when you need it
        tr
          td info
          td string
          td
          td Custom additional text with information about input
        tr
          td name
          td string
          td
          td Input name
        tr
          td placeholder
          td string
          td
          td Input placeholder
        tr
          td id
          td string
          td
          td Wrapping element ID attribute
        tr
          td inputId
          td string
          td
          td Input element ID attribute
        tr
          td value
          td string<br>number
          td
          td
            p Input value.
            p If `type="datepicker"` then value must be passed as what <a href="/docs/calendar.html" target="_blank">Calendar</a> accepts - Array with dates, for example `value={[new Date()]}`
            p If `type="colorpicker"` then value must be passed as what <a href="/docs/color-picker.html" target="_blank">Color Picker</a> accepts - Object with colors, for example `value={{hex: '#ff0000'}}`
            p If `type="texteditor"` then value should be HTML string
        tr
          td defaultValue
          td string<br>number
          td
          td Input value, in case of uncontrolled component
        tr
          td inputmode
          td string
          td
          td Value of input's native "inputmode" attribute
        tr
          td size
          td string<br>number
          td
          td Value of input's native "size" attribute
        tr
          td pattern
          td string
          td
          td Value of input's native "pattern" attribute
        tr
          td accept
          td string<br>number
          td
          td Value of input's native "accept" attribute
        tr
          td autocomplete
          td string
          td
          td Value of input's native "autocomplete" attribute
        tr
          td autofocus
          td boolean
          td false
          td Value of input's native "autofocus" attribute
        tr
          td autosave
          td string
          td
          td Value of input's native "autosave" attribute
        tr
          td checked
          td boolean
          td false
          td Marks input as checked
        tr
          td disabled
          td boolean
          td false
          td Marks input as disabled
        tr
          td max
          td string<br>number
          td
          td Value of input's native "max" attribute
        tr
          td min
          td string<br>number
          td
          td Value of input's native "min" attribute
        tr
          td step
          td string<br>number
          td
          td Value of input's native "step" attribute
        tr
          td maxlength
          td string<br>number
          td
          td Value of input's native "maxlength" attribute
        tr
          td minlength
          td string<br>number
          td
          td Value of input's native "minlength" attribute
        tr
          td multiple
          td boolean
          td false
          td Value of input's native "multiple" attribute
        tr
          td readonly
          td boolean
          td false
          td Marks input as readonly
        tr
          td required
          td boolean
          td false
          td Marks input as required
        tr
          td tabindex
          td string<br>number
          td
          td Value of input's native "tabindex" attribute
        tr
          td noStoreData
          td boolean
          td false
          td Allows to ignore input value to be stored when using with <a href="../docs/form.html#form-storage">Form Storage</a>
        tr
          td ignoreStoreData
          td boolean
          td false
          td Same as previous
        tr
          td calendarParams
          td object
          td
          td Object with <a href="../docs/calendar.html#calendar-parameters" target="_blank">Calendar Parameters</a> which is used when `type="datepicker"`
        tr
          td colorPickerParams
          td object
          td
          td Object with <a href="../docs/color-picker.html#color-picker-parameters" target="_blank">Color Picker Parameters</a> which is used when `type="colorpicker"`
        tr
          td textEditorParams
          td object
          td
          td Object with <a href="../docs/text-editor.html#text-editor-parameters" target="_blank">Text Editor Parameters</a> which is used when `type="texteditor"`

    h2 Input Events
    table.events-table
      thead
        tr
          th Event
          th Arguments
          th Description
      tbody
        tr
          th(colspan="3") &lt;ListInput&gt;, &lt;Input&gt; events
        tr
          td focus
          td <span>(event)</span>
          td Fired when user focused to input.
        tr
          td blur
          td <span>(event)</span>
          td Fired when user lost focus from input.
        tr
          td input
          td <span>(event)</span>
          td Fired immediately when input value changed. Note: Input event triggers after beforeinput, keypress, keyup, keydown events.
        tr
          td change
          td <span>(event)</span>
          td Fired on blur if value changed.
        tr
          td inputClear
          td <span>(event)</span>
          td Fired when input clear button clicked
        tr
          td textareaResize
          td <span>(event)</span>
          td Fired if resizable textarea resized. `event.detail` will contain object with the `initialHeight`, `currentHeight` and `scrollHeight` properties
        tr
          td inputEmpty
          td <span>(event)</span>
          td Fired when input value becomes empty
        tr
          td inputNotEmpty
          td <span>(event)</span>
          td Fired when input value becomes not empty
        tr
          td calendarChange
          td <span>(value)</span>
          td Fired when `type="datepicker"` Calendar value changed. As an argument it receives array with selected dates.
        tr
          td colorPickerChange
          td <span>(value)</span>
          td Fired when `type="colorpicker"` Color Picker value changed. As an argument it receives object with Color Picker value.
        tr
          td textEditorChange
          td <span>(value)</span>
          td Fired when `type="texteditor"` Text Editor value changed. As an argument it receives Texteditor value (HTML string).

    h2 Input Slots
    p `<ListInput>` has additional slots for custom elements:
    ul
      li `default` - in case of `type="select"` or `type="textarea"` - element will be placed inside of `select` or `textarea` tags.
      li `info` - element will be inserted into container with info message
      li `error-message` - element will be inserted into container with error message
      li `label` - element will be inserted into container with input's label
      li `input` - element will be inserted instead of input element (`input` prop must be also set to `false`)

      li `root-start` - element will be inserted in the beginning of `<li>` element
      li `root` / `root-end` - element will be inserted in the end of `<li>` element
      li `content-start` - element will be inserted in the beginning of `<div class="item-content">` element
      li `content` / `content-end` - element will be inserted in the end of `<div class="item-content">` element
      li `inner-start` - element will be inserted in the beginning of `<div class="item-inner">` element
      li `inner` / `inner-end` - element will be inserted in the end of `<div class="item-inner">` element
      li `media` - element will be inserted inside of `<div class="item-media">` element

    h2 Examples
    +examplePreview('react', 'inputs.jsx', 'inputs')
